#

# This isn't for any special cd, but just contains generally useful functions
# for formatting OM as latex.

#
# Takes a application node and a format and produces format(a1,a2,...)
#

sub function_of_n_variables {
	my ($node,$fnfmt) = @_;
	my $head = $node->{'head'};
	my $args = $node->{'args'};
	my @fargs;
	my $arg;
	my $fmt;
	
	foreach $arg ( @$args ) {
		push(@fargs, &format_type($arg)->{'sfmt'});
	}
	$fmt = $fnfmt . '\left(' . join(',', @fargs) . '\right) ';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

#
# Takes a application node and a format and produces "a1 format a2 format ..."
# adding brackets as necessary.
#

sub infix_op {
	my ($node,$fnfmt) = @_;
	my $head = $node->{'head'};
	my $args = $node->{'args'};
	my @fargs;
	my $arg;
	my $fmt;
	
	foreach $arg ( @$args ) {
		push(@fargs, &tex_bracket_sfmt(&format_type($arg)));
	}
	$fmt = join($fnfmt, @fargs);

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

#
# Takes a application node and a format and produces a1 format a2
#

sub binary_reln {
	my ($node,$fnfmt) = @_;
	my $head = $node->{'head'};
	my $args = $node->{'args'};
	my @fargs;
	my $arg;
	my $fmt;
	
	foreach $arg ( @$args ) {
		push(@fargs, &format_type($arg)->{'sfmt'} );
	}
	$fmt = join($fnfmt, @fargs);

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

#
# Brackets fmt using lpren and rpren.
#

sub tex_bracket_fmt {
	my ($format) = @_;

	return $format->{'lpren'} . $format->{'fmt'} . $format->{'rpren'};
}

#
# Brackets sfmt using lpren and rpren.
#

sub tex_bracket_sfmt {
	my ($format) = @_;

	return $format->{'lpren'} . $format->{'sfmt'} . $format->{'rpren'};
}

1;
