#

$thiscd = 'arith2';

$cdformatter{$thiscd} = {
	'arg' => {
		'symbol'      => \&tex_arith2_arg_symbol,
		'application' => \&tex_arith2_arg_application,
		},
	'inverse' => {
		'symbol'      => \&tex_arith2_inverse_symbol,
		'application' => \&tex_arith2_inverse_application,
		},
	'times' => {
		'symbol'      => \&tex_arith2_times_symbol,
		'application' => \&tex_arith2_times_application,
		},
};

sub tex_arith2_arg_symbol {
	return ({'fmt' => '\arg ', 'sfmt' => '\arg ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_arith2_arg_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("arg with wrong number of args.\n");
	}

	$fmt = '\arg \left( ' . &format_type($args->[0])->{'sfmt'} . ' \right)';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_arith2_inverse_symbol {
	return ({'fmt' => '\mbox{inverse}', 'sfmt' => '\mbox{inverse}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_arith2_inverse_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("inverse with wrong number of args.\n");
	}

	$fmt = &tex_bracket_sfmt(&format_type($args->[0])) . '^{-1}';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_arith2_times_symbol {
	return ({'fmt' => '{\times}', 'sfmt' => '{\times}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_arith2_times_application {
	my ($node) = @_;

	return &infix_op($node,'{\times}');
}


1;
