#

$thiscd = 'fns1';

$cdformatter{$thiscd} = {
	'identity' => {
		'symbol' => \&tex_fns1_identity_symbol,
		},
	'inverse' => {
		'symbol' => \&tex_fns1_inverse_symbol,
		'application' => \&tex_fns1_inverse_application,
		},
	'lambda' => {
		'symbol' => \&tex_fns1_lambda_symbol,
		},
	'left_compose' => {
		'symbol' => \&tex_fns1_left_compose_symbol,
		'application' => \&tex_fns1_left_compose_application,
		},
};

sub tex_fns1_lambda_symbol {
	return ({'fmt' => '\lambda ', 'sfmt' => '\lambda ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns1_identity_symbol {
	return ({'fmt' => 'I ', 'sfmt' => 'I ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns1_inverse_symbol {
	return ({'fmt' => '\mbox{inverse}', 'sfmt' => '\mbox{inverse}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns1_inverse_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("inverse with wrong number of args.\n");
	}

	$fmt = &tex_bracket_fmt(&format_type($args->[0])) . '^{-1}';
		

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_fns1_left_compose_symbol {
	return ({'fmt' => '\circ ', 'sfmt' => '\circ ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns1_left_compose_application {
	my ($node) = @_;

	return &infix_op($node,'\circ ');
}

1;
