#

$thiscd = 'fns2';

$cdformatter{$thiscd} = {
	'apply_to_list' => {
		'symbol' => \&tex_fns2_apply_to_list_symbol,
		'application' => \&tex_fns2_apply_to_list_application,
		},
	'domain' => {
		'symbol' => \&tex_fns2_domain_symbol,
		'application' => \&tex_fns2_domain_application,
		},
	'image' => {
		'symbol' => \&tex_fns2_image_symbol,
		'application' => \&tex_fns2_image_application,
		},
	'kernel' => {
		'symbol' => \&tex_fns2_kernel_symbol,
		'application' => \&tex_fns2_kernel_application,
		},
	'right_compose' => {
		'symbol' => \&tex_fns2_right_compose_symbol,
		},
};

sub tex_fns2_apply_to_list_symbol {
	return ({'fmt' => '\mbox{apply\_to\_list}', 'sfmt' => '\mbox{apply\_to\_list}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns2_apply_to_list_application {
	my ($node) = @_;
	my $head = $node->{'head'};
	my $args = $node->{'args'};
	my @fargs;
	my $arg;
	my $fmt;
	
	foreach $arg ( @$args ) {
		push(@fargs, &format_type($arg)->{'sfmt'});
	}
	shift(@fargs);
	$fmt = &tex_bracket_fmt(&format_type($args->[0])) . join(',', @fargs);

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns2_domain_symbol {
	return ({'fmt' => '\mbox{Dom}', 'sfmt' => '\mbox{Dom}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns2_domain_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("domain with wrong number of args.\n");
	}

	$fmt = '\mbox{Dom} ' . &tex_bracket_fmt(&format_type($args->[0]));

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_fns2_image_symbol {
	return ({'fmt' => '\mbox{Img}', 'sfmt' => '\mbox{Img}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns2_image_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("image with wrong number of args.\n");
	}

	$fmt = '\mbox{Img} ' . &tex_bracket_fmt(&format_type($args->[0]));

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_fns2_kernel_symbol {
	return ({'fmt' => '\ker ', 'sfmt' => '\ker ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_fns2_kernel_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("kernel with wrong number of args.\n");
	}

	$fmt = '\ker ' . &tex_bracket_fmt(&format_type($args->[0]));

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_fns2_right_compose_symbol {
	return ({'fmt' => '\mbox{right\_compose}', 'sfmt' => '\mbox{right\_compose}',
		'lpren' => '', 'rpren' => ''});
}

1;
