#

$thiscd = 'integer';

$cdformatter{$thiscd} = {
	'factorial' => {
		'symbol'      => \&tex_integer_factorial_symbol,
		'application' => \&tex_integer_factorial_application,
		},
	'gcd' => {
		'symbol'      => \&tex_integer_intfn_symbol,
		'application' => \&tex_integer_intfn_application,
		},
	'quotient' => {
		'symbol'      => \&tex_integer_intfn_symbol,
		'application' => \&tex_integer_intfn_application,
		},
	'rem' => {
		'symbol'      => \&tex_integer_intfn_symbol,
		'application' => \&tex_integer_intfn_application,
		},
};

sub tex_integer_factorial_symbol {
	return ({'fmt' => '!', 'sfmt' => '!',
		'lpren' => '', 'rpren' => ''});
}

sub tex_integer_factorial_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("factorial with wrong number of args.\n");
	}

	$fmt = &tex_bracket_sfmt(&format_type($args->[0])) . '!';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

%texintegerfmt = (
	'gcd' => '\gcd ',
	'quotient' => '\mbox{quotient}',
	'rem' => '\mbox{rem}',
);

sub tex_integer_intfn_symbol {
	my ($node) = @_;
	my $fmt;

	$fmt = $texintegerfmt{$node->{'name'}};
	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_integer_intfn_application {
	my ($node) = @_;
	my $args = $node->{'args'};
	my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die($node->{'head'}->{'name'} . " with wrong number of args.\n");
	}
	$fmt = $texintegerfmt{$node->{'head'}->{'name'}};
	return &function_of_n_variables($node,$fmt);
}

1;
