#

$thiscd = 'interval';

$cdformatter{$thiscd} = {
	'integer_interval' => {
		'symbol'      => \&tex_interval_integer_interval_symbol,
		'application' => \&tex_interval_integer_interval_application,
		},
	'interval' => {
		'symbol'      => \&tex_interval_interval_symbol,
		'application' => \&tex_interval_interval_application,
		},
	'interval_cc' => {
		'symbol'      => \&tex_interval_interval_cc_symbol,
		'application' => \&tex_interval_interval_cc_application,
		},
	'interval_co' => {
		'symbol'      => \&tex_interval_interval_co_symbol,
		'application' => \&tex_interval_interval_co_application,
		},
	'interval_oc' => {
		'symbol'      => \&tex_interval_interval_oc_symbol,
		'application' => \&tex_interval_interval_oc_application,
		},
	'interval_oo' => {
		'symbol'      => \&tex_interval_interval_oo_symbol,
		'application' => \&tex_interval_interval_oo_application,
		},
};

sub tex_interval_integer_interval_symbol {
	return ({'fmt' => '\mbox{integer\_interval}', 'sfmt' => '\mbox{integer\_interval}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_integer_interval_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die("integer_interval with wrong number of args.\n");
	}

	$fmt = &format_type($args->[0])->{'sfmt'} . ' .. ' .
		&format_type($args->[1])->{'sfmt'} ;

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left\{', 'rpren' => '\right\}'});
}

sub tex_interval_interval_symbol {
	return ({'fmt' => '\mbox{interval}', 'sfmt' => '\mbox{interval}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_interval_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die("interval with wrong number of args.\n");
	}

	$fmt = &format_type($args->[0])->{'sfmt'} . ' \rightarrow ' .
		&format_type($args->[1])->{'sfmt'} ;

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left\{', 'rpren' => '\right\}'});
}

sub tex_interval_interval_cc_symbol {
	return ({'fmt' => '\mbox{closed interval}', 'sfmt' => '\mbox{closed interval}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_interval_cc_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die("closed interval with wrong number of args.\n");
	}

	$fmt = '\left[' . &format_type($args->[0])->{'sfmt'} . ',' .
		&format_type($args->[1])->{'sfmt'} . '\right]';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_interval_co_symbol {
	return ({'fmt' => '\mbox{half open interval}', 'sfmt' => '\mbox{half open interval}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_interval_co_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die("half open interval with wrong number of args.\n");
	}

	$fmt = '\left[ ' . &format_type($args->[0])->{'sfmt'} . ',' .
		&format_type($args->[1])->{'sfmt'} . '\right) ';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_interval_oc_symbol {
	return ({'fmt' => '\mbox{half open interval}', 'sfmt' => '\mbox{half open interval}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_interval_oc_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die("half open interval with wrong number of args.\n");
	}

	$fmt = '\left( ' . &format_type($args->[0])->{'sfmt'} . ',' .
		&format_type($args->[1])->{'sfmt'} . '\right] ';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_interval_oo_symbol {
	return ({'fmt' => '\mbox{open interval}', 'sfmt' => '\mbox{open interval}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_interval_interval_oo_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die("open interval with wrong number of args.\n");
	}

	$fmt = '\left( ' . &format_type($args->[0])->{'sfmt'} . ',' .
		&format_type($args->[1])->{'sfmt'} . '\right) ';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

1;
