#

$thiscd = 'limit';

$cdformatter{$thiscd} = {
	'above' => {
		'symbol'      => \&tex_limit_above_symbol,
		},
	'below' => {
		'symbol'      => \&tex_limit_below_symbol,
		},
	'both_sides' => {
		'symbol'      => \&tex_limit_both_sides_symbol,
		},
	'limit' => {
		'symbol'      => \&tex_limit_limit_symbol,
		'application' => \&tex_limit_limit_application,
		},
	'null' => {
		'symbol'      => \&tex_limit_null_symbol,
		},
};

sub tex_limit_above_symbol {
	return ({'fmt' => '+', 'sfmt' => '+',
		'lpren' => '', 'rpren' => ''});
}

sub tex_limit_below_symbol {
	return ({'fmt' => '-', 'sfmt' => '-',
		'lpren' => '', 'rpren' => ''});
}

sub tex_limit_both_sides_symbol {
	return ({'fmt' => '{}', 'sfmt' => '{}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_limit_limit_symbol {
	return ({'fmt' => '{\lim}', 'sfmt' => '{\lim}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_limit_limit_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 3 ) {
		&format_die("arg with wrong number of args.\n");
	}

	$fmt = '\lim_{';

	&format_type($args->[2]);
	if( $args->[2]->{'type'} eq 'binding' ) {
		$fmt .= &format_type($args->[2]->{'vars'}->[0])->{'sfmt'} .
			'\rightarrow ' .
			&format_type($args->[0])->{'sfmt'} .
			'^' .
			&format_type($args->[1])->{'sfmt'};
	} else {
		$fmt .= &format_type($args->[0])->{'sfmt'} .
			'^' .
			&format_type($args->[1])->{'sfmt'};
	}

	$fmt .= '}' . &format_type($args->[2])->{'sfmt'} ;

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_limit_null_symbol {
	return ({'fmt' => '{}', 'sfmt' => '{}',
		'lpren' => '', 'rpren' => ''});
}


1;
