#

$thiscd = 'linalg1';

$cdformatter{$thiscd} = {
	'matrix' => {
		'symbol'      => \&tex_linalg1_matrix_symbol,
		'application' => \&tex_linalg1_matrix_application,
		},
	'matrixrow' => {
		'symbol'      => \&tex_linalg1_matrixrow_symbol,
		'application' => \&tex_linalg1_matrixrow_application,
		},
	'vector' => {
		'symbol'      => \&tex_linalg1_vector_symbol,
		'application' => \&tex_linalg1_vector_application,
		},
};

sub tex_linalg1_matrix_symbol {
	return ({'fmt' => '\mbox{matrix}', 'sfmt' => '\mbox{matrix}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_linalg1_matrix_application {
	my ($node) = @_;
	my $args = $node->{'args'};
	my $arg;
	my $arg2;
	my $fmt;
	my $maxlen;

	foreach $arg ( @$args ) {
		if( $arg->{'type'} ne 'application' ||
		    $arg->{'head'}->{'cd'} ne 'linalg1' ||
		    $arg->{'head'}->{'name'} ne 'matrixrow' ) {
			&format_die("matrix not followed by matrixrow\n");
		}
		if( scalar(@{$arg->{'args'}}) > $maxlen ) {
			$maxlen = scalar(@{$arg->{'args'}});
		}
		foreach $arg2 ( @{$arg->{'args'}} ) {
			$fmt .= &format_type($arg2)->{'sfmt'};
			if( $arg2 ne $arg->{'args'}[scalar(@{$arg->{'args'}})-1] ) {
				$fmt .= ' & ';
			}
		}
		$fmt .= '\\\\';
	}

	$fmt = '\left( \begin{array}{' . ('c' x $maxlen) . '}' .
		$fmt .
		'\end{array}\right) ';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_linalg1_matrixrow_symbol {
	return ({'fmt' => '\mbox{make\_list}', 'sfmt' => '\mbox{make\_list}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_linalg1_matrixrow_application {
	&format_die("matrix row outside matrix.\n");
}

sub tex_linalg1_vector_symbol {
	return ({'fmt' => '\mbox{vector}', 'sfmt' => '\mbox{vector}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_linalg1_vector_application {
	my ($node) = @_;
	my $args = $node->{'args'};
	my $arg;
	my $fmt;

	foreach $arg ( @$args ) {
		$fmt .= &format_type($arg)->{'sfmt'};
		if( $arg ne $node->{'args'}[scalar(@{$node->{'args'}})-1] ) {
			$fmt .= '\\\\';
		}
	}

	$fmt = '\left(\begin{array}{c}' .
		$fmt .
		'\end{array}\right)';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

1;
