#

$thiscd = 'linalg3';

$cdformatter{$thiscd} = {
	'determinant' => {
		'symbol'      => \&tex_linalg3_determinant_symbol,
		'application' => \&tex_linalg3_determinant_application,
		},
	'selector' => {
		'symbol'      => \&tex_linalg3_selector_symbol,
		'application' => \&tex_linalg3_selector_application,
		},
	'transpose' => {
		'symbol'      => \&tex_linalg3_transpose_symbol,
		'application' => \&tex_linalg3_transpose_application,
		},
};

sub tex_linalg3_determinant_symbol {
	return ({'fmt' => '\det ', 'sfmt' => '\det ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_linalg3_determinant_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("det with wrong number of args.\n");
	}

	$fmt = '\det ' . &tex_bracket_sfmt(&format_type($args->[0]));

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_linalg3_transpose_symbol {
	return ({'fmt' => '\mbox{transpose}', 'sfmt' => '\mbox{transpose}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_linalg3_transpose_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("transpose with wrong number of args.\n");
	}

	$fmt = &tex_bracket_sfmt(&format_type($args->[0])) .
		'^T';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_linalg3_selector_symbol {
	return ({'fmt' => '\mbox{selector}', 'sfmt' => '\mbox{selector}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_linalg3_selector_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die("selector with wrong number of args.\n");
	}

	$fmt = &tex_bracket_sfmt(&format_type($args->[1])) .
		'_{' . &format_type($args->[0])->{'fmt'} .
		'}';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

1;
