#

$thiscd = 'list1';

$cdformatter{$thiscd} = {
	'list' => {
		'symbol'      => \&tex_list1_list_symbol,
		'application' => \&tex_list1_list_application,
		},
	'make_list' => {
		'symbol'      => \&tex_list1_make_list_symbol,
		'application' => \&tex_list1_make_list_application,
		},
};

sub tex_list1_list_symbol {
	return ({'fmt' => '\mbox{list}', 'sfmt' => '\mbox{list}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_list1_list_application {
	my ($node) = @_;

	return &function_of_n_variables($node,'');
}

sub tex_list1_make_list_symbol {
	return ({'fmt' => '\mbox{make\_list}', 'sfmt' => '\mbox{make\_list}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_list1_make_list_application {
	my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

	if( scalar(@$args) != 3 ) {
		&format_die("make_list with wrong number of args.\n");
	}

	&format_type($args->[2]);
	if( $args->[2]->{'type'} eq 'binding' ) {
		$fmt = '\left( ' .
			&format_type($args->[2])->{'sfmt'} .
			' : ' .
			&format_type($args->[2]->{'vars'}->[0])->{'sfmt'} .
			' = ' .
			&format_type($args->[0])->{'sfmt'} .
			' .. ' .
			&format_type($args->[1])->{'sfmt'} .
			'\right) ';
	} else {
		$fmt = '\left( ' .
			&format_type($args->[2])->{'sfmt'} .
			' : ' .
			&format_type($args->[0])->{'sfmt'} .
			' .. ' .
			&format_type($args->[1])->{'sfmt'} .
			'\right) ';
	}

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

1;
