#

$thiscd = 'list2';

$cdformatter{$thiscd} = {
	'cons' => {
		'symbol'      => \&tex_list2_cons_symbol,
		'application' => \&tex_list2_cons_application,
		},
	'first' => {
		'symbol'      => \&tex_list2_first_symbol,
		'application' => \&tex_list2_first_application,
		},
	'rest' => {
		'symbol'      => \&tex_list2_rest_symbol,
		'application' => \&tex_list2_rest_application,
		},
};

sub tex_list2_cons_symbol {
	return ({'fmt' => '\mbox{cons}', 'sfmt' => '\mbox{cons}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_list2_cons_application {
	my ($node) = @_;
        my $args = $node->{'args'};
	my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die("cons with wrong number of args.\n");
	}

	$fmt = '\left( \mbox{cons},' .
		&format_type($args->[0])->{'sfmt'} . ',' .
		&format_type($args->[1])->{'sfmt'} . '\right) ';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_list2_first_symbol {
	return ({'fmt' => '\mbox{first}', 'sfmt' => '\mbox{first}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_list2_first_application {
	my ($node) = @_;
        my $args = $node->{'args'};
	my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("first with wrong number of args.\n");
	}

	$fmt = '\left( \mbox{first},' .
		&format_type($args->[0])->{'sfmt'} . '\right) ';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_list2_rest_symbol {
	my ($node) = @_;
	my $fmt;

	return ({'fmt' => '\mbox{rest}', 'sfmt' => '\mbox{rest}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_list2_rest_application {
	my ($node) = @_;
        my $args = $node->{'args'};
	my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("rest with wrong number of args.\n");
	}

	$fmt = '\left( \mbox{rest},' .
		&format_type($args->[0])->{'fmt'} . '\right) ';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

1;
