#

$thiscd = 'logic1';

$cdformatter{$thiscd} = {
	'and' => {
		'symbol' => \&tex_logic1_generic_symbol,
		'application' => \&tex_logic1_infix_application,
		},
	'false' => {
		'symbol' => \&tex_logic1_generic_symbol,
		},
	'implies' => {
		'symbol' => \&tex_logic1_generic_symbol,
		'application' => \&tex_logic1_relation_application,
		},
	'not' => {
		'symbol' => \&tex_logic1_generic_symbol,
		'application' => \&tex_logic1_not_application,
		},
	'or' => {
		'symbol' => \&tex_logic1_generic_symbol,
		'application' => \&tex_logic1_infix_application,
		},
	'true' => {
		'symbol' => \&tex_logic1_generic_symbol,
		},
	'xor' => {
		'symbol' => \&tex_logic1_generic_symbol,
		'application' => \&tex_logic1_infix_application,
		},
};

%texlogic1fmt = (
	'and' => '\wedge ',
	'false' => '\mbox{false}',
	'implies' => '\Rightarrow ',
	'not' => '\neg ',
	'or' => '\vee ',
	'true' => '\mbox{true}',
	'xor' => '\underline{\vee}',
);

sub tex_logic1_generic_symbol {
	my ($node) = @_;
	my $fmt;

	$fmt = $texlogic1fmt{$node->{'name'}};
	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_logic1_relation_application {
	my ($node) = @_;
	my $args = $node->{'args'};
	my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die($node->{'head'}->{'name'} . " with wrong number of args.\n");
	}

	$fmt = $texlogic1fmt{$node->{'head'}->{'name'}};
	return &binary_reln($node,$fmt);
}

sub tex_logic1_infix_application {
	my ($node) = @_;

	return &infix_op($node,$texlogic1fmt{$node->{'head'}->{'name'}});
}

sub tex_logic1_not_application {
	my ($node) = @_;
	my $head = $node->{'head'};
	my $args = $node->{'args'};
	my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die("unary minus with wrong number of args.\n");
	}

	$fmt = $texlogic1fmt{$node->{'head'}->{'name'}} .
		&tex_bracket_fmt(&format_type($args->[0]));

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}



1;
