#

$thiscd = 'nums';

$cdformatter{$thiscd} = {
	'based_integer' => {
		'application' => \&tex_nums_based_integer_application,
		},
	'complex_cartesian' => {
		'application' => \&tex_nums_complex_cartesian_application,
		},
	'complex_polar' => {
		'application' => \&tex_nums_complex_polar_application,
		},
	'e' => {
		'symbol'      => \&tex_nums_e_symbol,
		},
	'gamma' => {
		'symbol'      => \&tex_nums_gamma_symbol,
		},
	'i' => {
		'symbol'      => \&tex_nums_i_symbol,
		},
	'infinity' => {
		'symbol'      => \&tex_nums_infinity_symbol,
		},
	'NaN' => {
		'symbol'      => \&tex_nums_NaN_symbol,
		},
	'pi' => {
		'symbol'      => \&tex_nums_pi_symbol,
		},
	'rational' => {
		'application' => \&tex_nums_rational_application,
		},
};

sub tex_nums_based_integer_application {
        my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

        if( scalar(@$args) != 2 ) {
                &format_die("based_integer with wrong number of args.\n");
        }

        $fmt = '\left( ' . &format_type($args->[1])->{'sfmt'} . '\right)_{' .
		&format_type($args->[0])->{'sfmt'} . '}';

        return ({'fmt' => $fmt, 'sfmt' => $fmt,
                'lpren' => '', 'rpren' => ''});
}

sub tex_nums_complex_cartesian_application {
        my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

        if( scalar(@$args) != 2 ) {
                &format_die("complex_cartesian with wrong number of args.\n");
        }

        $fmt = &tex_bracket_sfmt(&format_type($args->[0])) . ' + ' .
		&tex_bracket_sfmt(&format_type($args->[1])) . 'i ';

        return ({'fmt' => $fmt, 'sfmt' => $fmt,
                'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_nums_complex_polar_application {
        my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

        if( scalar(@$args) != 2 ) {
                &format_die("complex_polar with wrong number of args.\n");
        }

        $fmt = &tex_bracket_sfmt(&format_type($args->[0])) . 'e^{i ' .
		&tex_bracket_sfmt(&format_type($args->[1])) . '}';

        return ({'fmt' => $fmt, 'sfmt' => $fmt,
                'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_nums_e_symbol {
	return ({'fmt' => 'e', 'sfmt' => 'e',
		'lpren' => '', 'rpren' => ''});
}

sub tex_nums_gamma_symbol {
	return ({'fmt' => '\gamma ', 'sfmt' => '\gamma ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_nums_i_symbol {
	return ({'fmt' => 'i ', 'sfmt' => 'i ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_nums_infinity_symbol {
	return ({'fmt' => '\infty ', 'sfmt' => '\infty ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_nums_NaN_symbol {
	return ({'fmt' => '\mbox{NaN}', 'sfmt' => '\mbox{NaN}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_nums_pi_symbol {
	return ({'fmt' => '\pi ', 'sfmt' => '\pi ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_nums_rational_application {
        my ($node) = @_;
        my $head = $node->{'head'};
        my $args = $node->{'args'};
        my $fmt;

        if( scalar(@$args) != 2 ) {
                &format_die("rational with wrong number of args.\n");
        }

        $fmt = '\frac{' . &format_type($args->[0])->{'sfmt'} . '}{' .
		&format_type($args->[1])->{'sfmt'} . '}';

        return ({'fmt' => $fmt, 'sfmt' => $fmt,
                'lpren' => '\left(', 'rpren' => '\right)'});
}

1;
