#

$thiscd = 'quant1';

$cdformatter{$thiscd} = {
	'exists' => {
		'symbol' => \&tex_quant1_exists_symbol,
		'binding' => \&tex_quant1_exists_binding,
		},
	'forall' => {
		'symbol' => \&tex_quant1_forall_symbol,
		'binding' => \&tex_quant1_forall_binding,
		},
};

sub tex_quant1_exists_symbol {
	return ({'fmt' => '\exists ', 'sfmt' => '\exists ',
		'lpren' => '', 'rpren' => ''});
}

sub tex_quant1_exists_binding {
	my ($node) = @_;
	my $binder = $node->{'binder'};
	my $vars = $node->{'vars'};
	my $body = $node->{'body'};
	my ($fbinder, @fvars, $fbody);
	my $var;
	my $fmt;

	$fbinder = '\exists ';
	foreach $var ( @$vars ) {
		pushbind($var);
		push(@fvars, &format_type($var)->{'fmt'});
	}
	$fbody = &format_type($body)->{'fmt'};
	foreach $var ( @$vars ) {
		popbind($var);
	}

	$fmt = $fbinder . join(',',@fvars) . '\mbox{ such that }' . $fbody ;

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

sub tex_quant1_forall_symbol {
	return ({'fmt' => '{\forall}', 'sfmt' => '{\forall}',
		'lpren' => '', 'rpren' => ''});
}

sub tex_quant1_forall_binding {
	my ($node) = @_;
	my $binder = $node->{'binder'};
	my $vars = $node->{'vars'};
	my $body = $node->{'body'};
	my ($fbinder, @fvars, $fbody);
	my $var;
	my $fmt;

	$fbinder = '\forall ';
	foreach $var ( @$vars ) {
		pushbind($var);
		push(@fvars, &format_type($var)->{'fmt'});
	}
	$fbody = &format_type($body)->{'fmt'};
	foreach $var ( @$vars ) {
		popbind($var);
	}

	$fmt = $fbinder .  join(',',@fvars) . '\mbox{ we have }' . $fbody;

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}

1;
