#

$thiscd = 'set1';

$cdformatter{$thiscd} = {
	'in' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_relation_application,
		},
	'intersect' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_infix_application,
		},
	'notin' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_relation_application,
		},
	'notprsubset' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_relation_application,
		},
	'notsubset' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_relation_application,
		},
	'prsubset' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_relation_application,
		},
	'set' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_set_application,
		},
	'setdiff' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_infix_application,
		},
	'subset' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_relation_application,
		},
	'union' => {
		'symbol' => \&tex_set1_generic_symbol,
		'application' => \&tex_set1_infix_application,
		},
};

%texset1fmt = (
	'in' => ' \in ',
	'intersect' => ' \cap ',
	'notin' => ' \not\in ',
	'notprsubset' => ' \not\subset ',
	'notsubset' => ' \not\subseteq ',
	'prsubset' => ' \subset ',
	'set' => '\mbox{set}',
	'setdiff' => ' \bigtriangledown ',
	'subset' => ' \subseteq ',
	'union' => ' \cup ',
);

sub tex_set1_generic_symbol {
	my ($node) = @_;
	my $fmt;

	$fmt = $texset1fmt{$node->{'name'}};
	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_set1_relation_application {
	my ($node) = @_;
	my $args = $node->{'args'};
	my $fmt;

	if( scalar(@$args) != 2 ) {
		&format_die($node->{'head'}->{'name'} . " with wrong number of args.\n");
	}

	$fmt = $texset1fmt{$node->{'head'}->{'name'}};
	return &binary_reln($node,$fmt);
}

sub tex_set1_infix_application {
	my ($node) = @_;
	my $args = $node->{'args'};

	return &infix_op($node,$texset1fmt{$node->{'head'}->{'name'}});
}

sub tex_set1_set_application {
	my ($node) = @_;
	my $head = $node->{'head'};
	my $args = $node->{'args'};
	my $fhead;
	my @fargs;
	my $arg;
	my $argformat;
	my ($fmt, $sfmt, $lpren, $rpren);
	
	foreach $arg ( @$args ) {
		$argformat = &format_type($arg);
		push(@fargs, $argformat->{'fmt'});
	}
	$fmt = '\left\{' . join(',', @fargs) . '\right\} ';

	$sfmt = $fmt;
	$lpren = '';
	$rpren = '';

	return ({'fmt' => $fmt, 'sfmt' => $sfmt,
		'lpren' => '', 'rpren' => ''});
}

1;
