#

$thiscd = 'stats1';

$cdformatter{$thiscd} = {
	'mean' => {
		'symbol'      => \&tex_stats1_fn_symbol,
		'application' => \&tex_stats1_fn_application,
		},
	'median' => {
		'symbol'      => \&tex_stats1_fn_symbol,
		'application' => \&tex_stats1_fn_application,
		},
	'mode' => {
		'symbol'      => \&tex_stats1_fn_symbol,
		'application' => \&tex_stats1_fn_application,
		},
	'moment' => {
		'symbol'      => \&tex_stats1_fn_symbol,
		'application' => \&tex_stats1_moment_application,
		},
	'sdev' => {
		'symbol'      => \&tex_stats1_fn_symbol,
		'application' => \&tex_stats1_fn_application,
		},
	'varience' => {
		'symbol'      => \&tex_stats1_fn_symbol,
		'application' => \&tex_stats1_fn_application,
		},
};

%texstats1fmt = (
	'mean' => '\mathbb{E}',
	'median' => '\mbox{median}',
	'mode' => '\mbox{mode}',
	'moment' => '\mbox{moment}',
	'sdev' => '\mbox{sdev}',
	'varience' => '\mbox{Var}',
);

sub tex_stats1_fn_symbol {
	my ($node) = @_;
	my $fmt;

	$fmt = $texstats1fmt{$node->{'name'}};
	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_stats1_fn_application {
	my ($node) = @_;
	my $args = $node->{'args'};
	my $fmt;

	$fmt = $texstats1fmt{$node->{'head'}->{'name'}};
	return &function_of_n_variables($node,$fmt);
}

sub tex_stats1_moment_application {
	my ($node) = @_;
	my $head = $node->{'head'};
	my $args = $node->{'args'};
	my @fargs;
	my $arg;
	my $fmt;
	
	foreach $arg ( @$args ) {
		$argformat = &format_type($arg);
		push(@fargs, $argformat->{'fmt'});
	}
	$fmt = '{' .
		$texstats1fmt{$node->{'head'}->{'name'}} .
		'_{' . shift(@fargs) . '}' .
		'\left(' . join(',', @fargs) . '\right)}';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

1;
