#

$thiscd = 'transc1';

$cdformatter{$thiscd} = {
	'arccos' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'arcsin' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'arctan' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'cos' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'cosh' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'cot' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'coth' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'csc' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'csch' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'exp' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'ln' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'log' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_log_application,
		},
	'sec' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'sech' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'sin' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'sinh' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'tan' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
	'tanh' => {
		'symbol'      => \&tex_transc1_trigfn_symbol,
		'application' => \&tex_transc1_trigfn_application,
		},
};

%textrigfmt = (
	'arccos' => '\arccos ',
	'arcsin' => '\arcsin ',
	'arctan' => '\arctan ',
	'cos' => '\cos ',
	'cosh' => '\cosh ',
	'cot' => '\cot ',
	'coth' => '\coth ',
	'csc' => '\csc ',
	'csch' => '\mbox{csch}',
	'exp' => '\exp ',
	'ln' => '\ln ',
	'log' => '\log ',
	'sec' => '\sec ',
	'sech' => '\mbox{sech}',
	'sin' => '\sin ',
	'sinh' => '\sinh ',
	'tan' => '\tan ',
	'tanh' => '\tanh ',
);

sub tex_transc1_trigfn_symbol {
	my ($node) = @_;
	my $fmt;

	$fmt = $textrigfmt{$node->{'name'}};
	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

sub tex_transc1_trigfn_application {
	my ($node) = @_;
	my $args = $node->{'args'};
	my $fmt;

	if( scalar(@$args) != 1 ) {
		&format_die($node->{'head'}->{'name'} . " with wrong number of args.\n");
	}
	$fmt = $textrigfmt{$node->{'head'}->{'name'}};
	return &function_of_n_variables($node,$fmt);
}

sub tex_transc1_log_application {
	my ($node) = @_;
	my $head = $node->{'head'};
	my $args = $node->{'args'};
	my @fargs;
	my $arg;
	my $fmt;
	
	if( scalar(@$args) != 2 ) {
		&format_die($node->{'head'}->{'name'} . " with wrong number of args.\n");
	}

	foreach $arg ( @$args ) {
		$argformat = &format_type($arg);
		push(@fargs, $argformat->{'fmt'});
	}
	$fmt = '{' .
		$textrigfmt{$node->{'head'}->{'name'}} .
		'_{' . shift(@fargs) . '}' .
		'\left(' . join(',', @fargs) . '\right)}';

	return ({'fmt' => $fmt, 'sfmt' => $fmt,
		'lpren' => '', 'rpren' => ''});
}

1;
