#

$thiscd = 'typmml';

$cdformatter{$thiscd} = {
	'type' => {
		'attribution'      => \&tex_typmml_type_symbol,
		},
};

%textypmmllist = (
	complex_cartesian_type => '\mbox{ is complex }',
	complex_polar_type => '\mbox{ is of complex polar type }',
	constant_type => '\mbox{ is a constant }',
	fn_type => '\mbox{ is a function }',
	integer_type => '\mbox{ is an integer }',
	list_type => '\mbox{ is a list }',
	matrix_type => '\mbox{ is a matrix }',
	rational_type => '\mbox{ is rational }',
	real_type => '\mbox{ is real }',
	set_type => '\mbox{ is a set }',
	vector_type => '\mbox{ is a vector }',
); 

sub tex_typmml_type_symbol {
	my ($node) = @_;
	my $object = $node->{'object'};
	my $attrs = $node->{'attrs'};
	my $atp;
	my $fmt;
	my $sfmt;

	$atp = $attrs->[0];
	$sfmt = &format_type($object)->{'sfmt'};
	if( $atp->{'value'}->{'type'} eq 'symbol' &&
	    $atp->{'value'}->{'cd'} eq 'typmml' &&
	    defined($textypmmllist{$atp->{'value'}->{'name'}}) ) {
		$fmt = $sfmt .
			$textypmmllist{$atp->{'value'}->{'name'}} .
			' , ' .
			&format_type($object)->{'fmt'};
	} else {
		$fmt = $sfmt .
			'\mbox{ has type }' .
			&format_type($atp->{'value'})->{'fmt'} .
			' , ' .
			&format_type($object)->{'fmt'};
	}

	return ({'fmt' => $fmt, 'sfmt' => $sfmt,
		'lpren' => '\left(', 'rpren' => '\right)'});
}


1;
